import { __awaiter, __generator, __read, __assign, __decorate, __metadata } from 'tslib';
import { Injectable, Inject, ɵɵdefineInjectable, ɵɵinject, NgModule } from '@angular/core';
import { DOCUMENT } from '@angular/common';
import { BehaviorSubject, Subject } from 'rxjs';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/interface.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function OneSignalStub() { }
if (false) {
    /** @type {?} */
    OneSignalStub.prototype.init;
    /** @type {?} */
    OneSignalStub.prototype.registerForPushNotifications;
    /** @type {?} */
    OneSignalStub.prototype.getUserId;
    /** @type {?} */
    OneSignalStub.prototype.setSubscription;
    /** @type {?} */
    OneSignalStub.prototype.isPushNotificationsEnabled;
    /** @type {?} */
    OneSignalStub.prototype.isOptedOut;
    /** @type {?} */
    OneSignalStub.prototype.isPushNotificationsSupported;
    /** @type {?} */
    OneSignalStub.prototype.subscriptionChange;
    /** @type {?} */
    OneSignalStub.prototype.push;
    /** @type {?} */
    OneSignalStub.prototype.on;
}
/**
 * initialize OneSignal.
 * @see {\@link https://documentation.onesignal.com/docs/web-push-sdk#section--init-}
 * @abstract
 */
var  /**
 * initialize OneSignal.
 * @see {\@link https://documentation.onesignal.com/docs/web-push-sdk#section--init-}
 * @abstract
 */
OneSignalOptions = /** @class */ (function () {
    function OneSignalOptions() {
    }
    return OneSignalOptions;
}());
if (false) {
    /** @type {?} */
    OneSignalOptions.prototype.appId;
    /** @type {?} */
    OneSignalOptions.prototype.autoRegister;
    /** @type {?} */
    OneSignalOptions.prototype.allowLocalhostAsSecureOrigin;
    /* Skipping unhandled member: [prop: string]: any;*/
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/decorators.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} initProp
 * @return {?}
 */
function ExecIf(initProp) {
    return (/**
     * @param {?} target
     * @param {?} name
     * @param {?} descriptor
     * @return {?}
     */
    function (target, name, descriptor) {
        /** @type {?} */
        var method = descriptor.value;
        descriptor.value = (/**
         * @return {?}
         */
        function () {
            console.log(this, arguments);
            if (this[initProp]) {
                return method.apply(this, arguments);
            }
            return void 0;
        });
    });
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/service/one-signal.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// @dynamic
var OneSignalService = /** @class */ (function () {
    function OneSignalService(doc, options) {
        this.doc = doc;
        this.options = options;
        this.scriptinitalize = false;
        this.scriptURL = 'https://cdn.onesignal.com/sdks/OneSignalSDK.js';
        this.isSupported$ = new BehaviorSubject(false);
        this.isSubscribe$ = new BehaviorSubject(false);
        this.isOptedOut$ = new BehaviorSubject(false);
        this.event$ = new Subject();
        this.isPushNotificationsEnabled$ = new BehaviorSubject(false);
        this.init();
    }
    Object.defineProperty(OneSignalService.prototype, "isSupported", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isSupported$.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OneSignalService.prototype, "isSubscribe", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isSubscribe$.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OneSignalService.prototype, "isInitialized", {
        get: /**
         * @return {?}
         */
        function () {
            return this.scriptinitalize;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OneSignalService.prototype, "isOptedOut", {
        get: /**
         * @return {?}
         */
        function () {
            return this.isOptedOut$.value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(OneSignalService.prototype, "event", {
        get: /**
         * @return {?}
         */
        function () {
            return this.event$;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    OneSignalService.prototype.subscribe = /**
     * @return {?}
     */
    function () {
        if (this.isSupported) {
            if (this.isOptedOut$.value) {
                OneSignal.setSubscription(true);
            }
            else {
                OneSignal.registerForPushNotifications();
            }
            this.listenForNotification();
        }
    };
    /**
     * call OneSignal.setSubscription(false)
     * @see {@link https://documentation.onesignal.com/docs/web-push-sdk#section--setsubscription-}
     */
    /**
     * call OneSignal.setSubscription(false)
     * @see {\@link https://documentation.onesignal.com/docs/web-push-sdk#section--setsubscription-}
     * @return {?}
     */
    OneSignalService.prototype.unsubscribe = /**
     * call OneSignal.setSubscription(false)
     * @see {\@link https://documentation.onesignal.com/docs/web-push-sdk#section--setsubscription-}
     * @return {?}
     */
    function () {
        if (this.isSubscribe) {
            OneSignal.setSubscription(false);
        }
    };
    /**
     * https://documentation.onesignal.com/docs/web-push-sdk#section-loading-sdk-asynchronously
     * @param items push(["functionName", param1, param2]);
     * @example
     * ngxOneSignal.push(['sendTag', 'key', 'value', function(tagsSent) {
     *   // Callback called when tags have finished sending
     * }]);
     * // or
     * ngxOneSignal.push(['sendTag', 'key', 'value']).then((tagsSent) => {
     *   // Callback called when tags have finished sending
     * });
     */
    /**
     * https://documentation.onesignal.com/docs/web-push-sdk#section-loading-sdk-asynchronously
     * \@example
     * ngxOneSignal.push(['sendTag', 'key', 'value', function(tagsSent) {
     *   // Callback called when tags have finished sending
     * }]);
     * // or
     * ngxOneSignal.push(['sendTag', 'key', 'value']).then((tagsSent) => {
     *   // Callback called when tags have finished sending
     * });
     * @param {?} items push(["functionName", param1, param2]);
     * @return {?}
     */
    OneSignalService.prototype.push = /**
     * https://documentation.onesignal.com/docs/web-push-sdk#section-loading-sdk-asynchronously
     * \@example
     * ngxOneSignal.push(['sendTag', 'key', 'value', function(tagsSent) {
     *   // Callback called when tags have finished sending
     * }]);
     * // or
     * ngxOneSignal.push(['sendTag', 'key', 'value']).then((tagsSent) => {
     *   // Callback called when tags have finished sending
     * });
     * @param {?} items push(["functionName", param1, param2]);
     * @return {?}
     */
    function (items) {
        if (this.isSupported) {
            return OneSignal.push(items);
        }
        else {
            return Promise.resolve();
        }
    };
    /**
     * @private
     * @return {?}
     */
    OneSignalService.prototype.init = /**
     * @private
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 4, , 5]);
                        if (!!this.scriptinitalize) return [3 /*break*/, 3];
                        return [4 /*yield*/, this.addScript()];
                    case 1:
                        _b.sent();
                        return [4 /*yield*/, this.initOneSignal()];
                    case 2:
                        _b.sent();
                        this.scriptinitalize = true;
                        _b.label = 3;
                    case 3: return [3 /*break*/, 5];
                    case 4:
                        _a = _b.sent();
                        this.scriptinitalize = false;
                        return [3 /*break*/, 5];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @private
     * @return {?}
     */
    OneSignalService.prototype.addScript = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        return new Promise((/**
         * @param {?} resolve
         * @param {?} reject
         * @return {?}
         */
        function (resolve, reject) {
            /** @type {?} */
            var head = _this.doc.getElementsByTagName('head')[0];
            /** @type {?} */
            var script = _this.doc.createElement('script');
            script.type = 'text/javascript';
            script.onload = resolve;
            script.onerror = reject;
            script.src = _this.scriptURL;
            head.appendChild(script);
        }));
    };
    /**
     * @private
     * @return {?}
     */
    OneSignalService.prototype.initOneSignal = /**
     * @private
     * @return {?}
     */
    function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c, _d, _e, _f, _g, _h;
            var _this = this;
            return __generator(this, function (_j) {
                switch (_j.label) {
                    case 0: return [4 /*yield*/, OneSignal.init(__assign({}, this.options))];
                    case 1:
                        _j.sent();
                        return [4 /*yield*/, OneSignal.on('subscriptionChange', (/**
                             * @param {?} isSubscribed
                             * @return {?}
                             */
                            function (isSubscribed) {
                                _this.isSubscribe$.next(isSubscribed);
                            }))];
                    case 2:
                        _j.sent();
                        // https://documentation.onesignal.com/docs/web-push-sdk#section-subscription-change
                        _b = (_a = this.isSupported$).next;
                        return [4 /*yield*/, OneSignal.isPushNotificationsSupported()];
                    case 3:
                        // https://documentation.onesignal.com/docs/web-push-sdk#section-subscription-change
                        _b.apply(_a, [_j.sent()]);
                        _d = (_c = this.isPushNotificationsEnabled$).next;
                        return [4 /*yield*/, OneSignal.isPushNotificationsEnabled()];
                    case 4:
                        _d.apply(_c, [_j.sent()]);
                        _f = (_e = this.isOptedOut$).next;
                        return [4 /*yield*/, OneSignal.isOptedOut()];
                    case 5:
                        _f.apply(_e, [_j.sent()]);
                        _h = (_g = this.isSubscribe$).next;
                        return [4 /*yield*/, Promise.all([
                                OneSignal.isPushNotificationsEnabled(),
                                OneSignal.isOptedOut(),
                            ]).then((/**
                             * @param {?} __0
                             * @return {?}
                             */
                            function (_a) {
                                var _b = __read(_a, 2), hasSubscribe = _b[0], hasOptedOut = _b[1];
                                return hasSubscribe && !hasOptedOut;
                            }))];
                    case 6:
                        _h.apply(_g, [_j.sent()]);
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @private
     * @return {?}
     */
    OneSignalService.prototype.listenForNotification = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        OneSignal.on('notificationDisplay', (/**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            console.log('OneSignal notification displayed:', event);
            _this.event$.next(event);
            _this.listenForNotification();
        }));
    };
    OneSignalService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    /** @nocollapse */
    OneSignalService.ctorParameters = function () { return [
        { type: Document, decorators: [{ type: Inject, args: [DOCUMENT,] }] },
        { type: OneSignalOptions }
    ]; };
    /** @nocollapse */ OneSignalService.ɵprov = ɵɵdefineInjectable({ factory: function OneSignalService_Factory() { return new OneSignalService(ɵɵinject(DOCUMENT), ɵɵinject(OneSignalOptions)); }, token: OneSignalService, providedIn: "root" });
    __decorate([
        ExecIf('isInitialized'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], OneSignalService.prototype, "subscribe", null);
    __decorate([
        ExecIf('isInitialized'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], OneSignalService.prototype, "unsubscribe", null);
    __decorate([
        ExecIf('isInitialized'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Array]),
        __metadata("design:returntype", void 0)
    ], OneSignalService.prototype, "push", null);
    return OneSignalService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.scriptinitalize;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.scriptURL;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.isSupported$;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.isSubscribe$;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.isOptedOut$;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.event$;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.isPushNotificationsEnabled$;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.doc;
    /**
     * @type {?}
     * @private
     */
    OneSignalService.prototype.options;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/one-signal.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxOneSignalModule = /** @class */ (function () {
    function NgxOneSignalModule() {
    }
    /**
     * @param {?=} options
     * @return {?}
     */
    NgxOneSignalModule.forRoot = /**
     * @param {?=} options
     * @return {?}
     */
    function (options) {
        return {
            ngModule: NgxOneSignalModule,
            providers: [{ provide: OneSignalOptions, useValue: options }],
        };
    };
    NgxOneSignalModule.decorators = [
        { type: NgModule }
    ];
    return NgxOneSignalModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public_api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-onesignal.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxOneSignalModule, OneSignalOptions, OneSignalService, ExecIf as ɵa };
//# sourceMappingURL=ngx-onesignal.js.map
