import { OneSignalOptions } from '../interface';
import { Subject } from 'rxjs';
export declare class OneSignalService {
    private readonly doc;
    private readonly options;
    private scriptinitalize;
    private readonly scriptURL;
    private readonly isSupported$;
    private readonly isSubscribe$;
    private readonly isOptedOut$;
    private readonly event$;
    private readonly isPushNotificationsEnabled$;
    get isSupported(): boolean;
    get isSubscribe(): boolean;
    get isInitialized(): boolean;
    get isOptedOut(): boolean;
    get event(): Subject<any>;
    subscribe(): void;
    /**
     * call OneSignal.setSubscription(false)
     * @see {@link https://documentation.onesignal.com/docs/web-push-sdk#section--setsubscription-}
     */
    unsubscribe(): void;
    /**
     * https://documentation.onesignal.com/docs/web-push-sdk#section-loading-sdk-asynchronously
     * @param items push(["functionName", param1, param2]);
     * @example
     * ngxOneSignal.push(['sendTag', 'key', 'value', function(tagsSent) {
     *   // Callback called when tags have finished sending
     * }]);
     * // or
     * ngxOneSignal.push(['sendTag', 'key', 'value']).then((tagsSent) => {
     *   // Callback called when tags have finished sending
     * });
     */
    push(items: undefined[]): Promise<any>;
    constructor(doc: Document, options: OneSignalOptions);
    private init;
    private addScript;
    private initOneSignal;
    private listenForNotification;
}
