"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const schematics_1 = require("@angular-devkit/schematics");
const tasks_1 = require("@angular-devkit/schematics/tasks");
const dependencies_1 = require("./installer/dependencies");
const ngx_onesignal_1 = require("./installer/ngx-onesignal");
const versions_1 = require("../util/versions");
const dependencies_2 = require("@schematics/angular/utility/dependencies");
function ngxOnesignal(options) {
    return (tree, context) => {
        return schematics_1.chain([
            ngx_onesignal_1.addPackageJsonDependencies('ngx-onesignal', process.env.HAS_SANDBOX ? `file:../ngx-onesignal.tgz` : versions_1.appVersion, dependencies_2.NodeDependencyType.Default),
            ngx_onesignal_1.addPackageJsonDependencies('@angular/cdk', versions_1.angularCdkVersion, dependencies_2.NodeDependencyType.Dev),
            dependencies_1.installDependencies(),
            setupProject(options),
        ])(tree, context);
    };
}
exports.ngxOnesignal = ngxOnesignal;
function setupProject(options) {
    return (tree, context) => {
        const installTaskId = context.addTask(new tasks_1.NodePackageInstallTask());
        context.addTask(new tasks_1.RunSchematicTask('setup', options), [
            installTaskId,
        ]);
        return tree;
    };
}
//# sourceMappingURL=index.js.map