"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const dependencies_1 = require("@schematics/angular/utility/dependencies");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
function addPackageJsonDependencies(pkgName, version, type) {
    return (tree, context) => {
        return rxjs_1.of(pkgName).pipe(operators_1.map(name => {
            const nodeDependency = {
                type,
                name,
                version,
                overwrite: false,
            };
            dependencies_1.addPackageJsonDependency(tree, nodeDependency);
            context.logger.info(`✅️ Added dependency: ${name}`);
            return tree;
        }));
    };
}
exports.addPackageJsonDependencies = addPackageJsonDependencies;
//# sourceMappingURL=ngx-onesignal.js.map